-- =============================================================================
-- File:		DKP_Tooltip.lua
-- Tooltip by:		Mist of Cho'gall www.symbolicguild.com
-- Linked mod by:	(synd][cate) 
--          		Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
-- 
-- Description:	Displays a Tooltip next to your regular item tooltip containing DKP Information
-- 
-- Some portions of code from the "GETDKP Plus" Mod by Corgan are also used.
-- 
-- Created: May 28, 2006
-- Modified: Aug 23, 2006
-- =============================================================================

-- -----------------------------------------
-- Local Variables                       --
-- -----------------------------------------
-- Declared colour codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";

local ClassColours = {		
	["WL"] = "|c009382c9",
	["WA"] = "|c00C69B6D",	
	["SH"] = "|c00F48CBA",
	["MA"] = "|c0068CCEF",
	["HU"] = "|c00AAD372",
	["PR"] = "|c00FFFFFF",
	["PA"] = "|c00F48CBA",
	["RO"] = "|c00FFF468",
	["DR"] = "|c00FF7C0A",		
};

local version = "2.1";

-- GUI Variables
local Original_ChatFrame_OnHyperlinkShow;
local Orig_ChatFrame_OnHyperlinkClick;
local TooltipLinesLocal = 1 ;
local bankcharname = bank_name;
local outputtable = {};
local txtcolors = {"RED", "GREEN", "BLUE", "MAGENTA", "YELLOW", "CYAN", "WHITE"};
local prisystem = 0;

DKP_TT_Settings = {};

-------------------------------------------
-- Functions				 --
-------------------------------------------

-- ############################################################ REGISTER EVENT HOOKS ########################################################
function DKP_Tooltip_OnLoad()
	this:RegisterEvent("ADDON_LOADED");	
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	-- Tooltip Slash Command
		SLASH_DKPS_TOOLTIP1 = "/dkptt";
		SlashCmdList["DKPS_TOOLTIP"] = function( msg )
			DKP_Tooltip_SlashCommandHandler( msg );
		end	
	
	DEFAULT_CHAT_FRAME:AddMessage(CYAN .. "DKP_Tooltip Version:" ..version.. " Loaded -- Created by Mist");
end

-- ############################################################ LOAD ON ITEM LINK CLICK HOOK ################################################
function DKP_Tooltip_OnEvent()

	if event == "VARIABLES_LOADED" then
		Orig_ChatFrame_OnHyperlinkClick = ChatFrame1:GetScript("OnHyperlinkClick");
		ChatFrame1:SetScript("OnHyperlinkClick", DKP_Tooltip_Update);
		for i = 2, 15 do
			if (getglobal("ChatFrame"..i)) then
				local cf = getglobal("ChatFrame"..i);
				cf:SetScript("OnHyperlinkClick", DKP_Tooltip_Update);
			end			
		end
	if (DKP_TT_Settings.Tooltip_Location == nil) then
		DKP_TT_Settings.Tooltip_Location = "top";
	end
	if (DKP_TT_Settings.Outputchan == nil) then
		DKP_TT_Settings.Outputchan = "";
	end
	-- if (DKP_TT_Settings.Activated == "no") then
	-- 	Disablethismod = true;
	-- else
	-- 	Disablethismod = false;
	-- end
	
	if (DKP_TT_Settings.TT_LINE1_C ~= nil) then
		TT_LINE1_C = DKP_TT_Settings.TT_LINE1_C;
	else
		TT_LINE1_C = "ITEM";
	end
	if (DKP_TT_Settings.TT_LINE2_C ~= nil) then
		TT_LINE2_C = DKP_TT_Settings.TT_LINE2_C;
	else
		TT_LINE2_C = "RGB_CYAN";
	end
	if (DKP_TT_Settings.TT_LINE3_C ~= nil) then
		TT_LINE3_C = DKP_TT_Settings.TT_LINE3_C;
	else
		TT_LINE3_C = "RGB_WHITE";
	end
	if (DKP_TT_Settings.TT_LINE4_C ~= nil) then
		TT_LINE4_C = DKP_TT_Settings.TT_LINE4_C;
	else
		TT_LINE4_C = "RGB_CYAN";
	end
	if (DKP_TT_Settings.TT_LINE5_C ~= nil) then
		TT_LINE5_C = DKP_TT_Settings.TT_LINE5_C;
	else
		TT_LINE5_C = "RGB_YELLOW";
	end
	if (DKP_TT_Settings.TT_LINE6_C ~= nil) then
		TT_LINE6_C = DKP_TT_Settings.TT_LINE6_C;
	else
		TT_LINE6_C = "RGB_RED";
	end
	if (DKP_TT_Settings.TT_LINE7_C ~= nil) then
		TT_LINE7_C = DKP_TT_Settings.TT_LINE7_C;
	else
		TT_LINE7_C = "RGB_GREEN";
	end
	if (DKP_TT_Settings.TT_LINE8_C ~= nil) then
		TT_LINE8_C = DKP_TT_Settings.TT_LINE8_C;
	else
		TT_LINE8_C = "RGB_YELLOW";
	end
	if (DKP_TT_Settings.TT_LINE9_C ~= nil) then
		TT_LINE9_C = DKP_TT_Settings.TT_LINE9_C;
	else
		TT_LINE9_C = "RGB_YELLOW";
	end
	if (DKP_TT_Settings.TT_LINE10_C ~= nil) then
		TT_LINE10_C = DKP_TT_Settings.TT_LINE10_C;
	else
		TT_LINE10_C = "RGB_YELLOW";
	end
	if (DKP_TT_Settings.TT_LINE11_C ~= nil) then
		TT_LINE11_C = DKP_TT_Settings.TT_LINE11_C;
	else
		TT_LINE11_C = "RGB_RED";
	end
	
	if (DKP_TT_Settings.TT_LINE2_D == "off") then
		TT_LINE2_D = false;
	else
		TT_LINE2_D = true;
	end
	if (DKP_TT_Settings.TT_LINE3_D == "off") then
		TT_LINE3_D = false;
	else
		TT_LINE3_D = true;
	end
	if (DKP_TT_Settings.TT_LINE4_D == "off") then
		TT_LINE4_D = false;
	else
		TT_LINE4_D = true;
	end
	if (DKP_TT_Settings.TT_LINE5_D == "off") then
		TT_LINE5_D = false;
	else
		TT_LINE5_D = true;
	end
	if (DKP_TT_Settings.TT_LINE6_D == "off") then
		TT_LINE6_D = false;
	else
		TT_LINE6_D = true;
	end
	if (DKP_TT_Settings.TT_LINE7_D == "off") then
		TT_LINE7_D = false;
	else
		TT_LINE7_D = true;
	end
	if (DKP_TT_Settings.TT_LINE8_D == "off") then
		TT_LINE8_D = false;
	else
		TT_LINE8_D = true;
	end
	if (DKP_TT_Settings.TT_LINE9_D == "off") then
		TT_LINE9_D = false;
	else
		TT_LINE9_D = true;
	end
	if (DKP_TT_Settings.TT_LINE10_D == "off") then
		TT_LINE10_D = false;
	else
		TT_LINE10_D = true;
	end
	if (DKP_TT_Settings.TT_LINE11_D == "off") then
		TT_LINE11_D = false;
	else
		TT_LINE11_D = true;
	end
	end	
end

-- ############################################################ CREATE AND DISPLAY TOOLTIP ###################################################
function DKP_Tooltip_Update()
	Orig_ChatFrame_OnHyperlinkClick();
	
	getdkplootwidth = 0;
	TooltipLinesLocal = 1 ;
	
	local tooltiploc = DKP_TT_Settings.Tooltip_Location;
	
	if (tooltiploc == nil) or (tooltiploc == "top") then
		point="BOTTOMLEFT" ; 
		relative="TOPLEFT";			
	elseif tooltiploc == "left" then 
		point="TOPRIGHT" ; 
		relative="TOPLEFT";			
	elseif tooltiploc == "right" then 
		point="TOPLEFT" ; 
		relative="TOPRIGHT";
	elseif tooltiploc == "bottom" then 
		point="TOPLEFT" ; 
		relative="BOTTOMLEFT";
	end;
	
	local Firstline = ItemRefTooltipTextLeft1:GetText();
	r,g,b,a = ItemRefTooltipTextLeft1:GetTextColor();
	local itemcolorr = r;
	local itemcolorg = g;
	local itemcolorb = b;
	local itemcolora = a;
	local returnResult, foundResult;
	local playerName, playerAttrib, playerNameUpper;
	local itemName, itemCost, itemNameUpper, itemPriorities;
	local AttribName;
	local AttribValue;
	local itemsfound = 0;
	local _min,_max, _avg, _itemcount
	local prioutput, prioutput2;
	
	if (outputtable ~= nil) then
		outputtable = {}
	 end

	if (Firstline == nil) or (Firstline == "") then
		return
	end

	local KeyWord = string.lower(Firstline);	
	
	CLASSNAME_DE,CLASSNAME_ENG,anamede,anameeng,atier,adrop = get_Informations_of_Item(Firstline) ;
	_min,_max, _avg, _itemcount = DKPSYS_item_info(Firstline);
		
	if (Firstline == nil) or (Firstline == "") then
		return
	end
	
	for i = 1, 47 do
		local getdkplootlayer = getglobal("DKPSysTTPanelText"..i);
		getdkplootlayer:Hide();
	end
	
	getdkplootlineSetLine(Firstline, TT_LINE1_C, itemcolora);
	table.insert(outputtable,DKPSYS_TT_ITEM_INFO .. DKPSYS_Check_Loot_Text(Firstline));
		
	local playerName, playerArray, playerKey, playerValue, playerPoints, playerRank;
	local PlayerNames = {};		
	local PlayerRaidPoints = {};
		
	local playerNameUpper;
	local a,b,n1,n2;
		
	local results = 0;
	local noofplayers = 0;
	local itemsfound = 0;
		
	local lastreport = "";
		
	for playerName, playerArray in DKP_ROLL_PLAYERS do
		for playerKey, playerValue in playerArray do
			if (playerKey == "RaidPoints") then
				if ((string.lower(DKP_ROLL_PLAYERS[playerName]['Class']) == string.lower(CLASSNAME_ENG)) or 
					(CLASSNAME_DE == "ALL")) then
						if playerName ~= bankcharname then
							PlayerRaidPoints[playerName] = playerValue;
							table.insert(PlayerNames, playerName);
							itemsfound = itemsfound +1;
						end
				end
			end
		end
	end
		
		table.sort(PlayerNames, function (n1, n2)
        return PlayerRaidPoints[n1] > PlayerRaidPoints[n2]
    end)

	if (itemsfound > 0) or (_itemcount > 0) then 	
		noofplayers = table.getn(PlayerNames)
		doesown,bankitem = checkifownsitem(bankcharname, Firstline); 
		
		if noofplayers > 0 then
			if (TT_LINE2_D) then
				getdkplootlineSetLine("There are " ..noofplayers.. " " ..CLASSNAME_ENG.. "'s", TT_LINE2_C);
			end
			if (atier ==1) or (atier ==2)  then 
				tiertext = "Tier"
			else
				tiertext = " "
			end;
			
			if (TT_LINE3_D) then
				getdkplootlineSetLine(CLASSNAME_ENG.. " " ..tiertext .. atier, TT_LINE3_C);
				table.insert(outputtable,CLASSNAME_ENG.. " " ..tiertext .. atier);
			end
			if (TT_LINE4_D) then
				getdkplootlineSetLine('Mob: '..adrop, TT_LINE4_C);
			end
		else
			if (bankitem) then
				if (TT_LINE5_D) then
					getdkplootlineSetLine("Listed under the Bank at: " ..DKP_ROLL_PLAYERS[bankcharname]['Items'][Firstline]['cost'].. "DKP", TT_LINE5_C);
					table.insert(outputtable,"Listed under the Bank at: " ..DKP_ROLL_PLAYERS[bankcharname]['Items'][Firstline]['cost'].. "DKP");
				end
			end
		end
	    a = 1;
			for playerRank, playerName in PlayerNames do
				playerNameUpper = string.upper(playerName);	
				if (DKP_ROLL_PLAYERS[playerName]['Items'] ~= nil) then
					playerNameUpper = string.upper(playerName);								
					doesown = false;
					bankitem = false;
					doesown,bankitem,itempriorities = checkifownsitem(playerName, Firstline); 
					playerinraid = DKPSYS_chkinraid(playerName);
				
					if not (bankitem) then
						if (doesown) then
							if (playerinraid) then
								if (TT_LINE7_D) then
									getdkplootlineSetLine("  +" ..YELLOW.. "(R) " .. GREEN .. playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[playerName]['Items'][Firstline]['cost'].. "DKP", TT_LINE7_C);
									table.insert(outputtable,"  +(R) " ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[playerName]['Items'][Firstline]['cost'].. "DKP");
								end
								results = results +1;
							else
								if (TT_LINE7_D) then
									getdkplootlineSetLine("  +" ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[playerName]['Items'][Firstline]['cost'].. "DKP", TT_LINE7_C);
									table.insert(outputtable,"  +" ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[playerName]['Items'][Firstline]['cost'].. "DKP");
								end
								results = results +1;
							end

						else
							if (playerinraid) then
								if (TT_LINE6_D) then
									getdkplootlineSetLine("  -" ..YELLOW.. "(R) " .. RED .. playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)", TT_LINE6_C);
									table.insert(outputtable,"  -(R) " ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)");
								end
							else
								if (TT_LINE6_D) then
									getdkplootlineSetLine("  -" ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)", TT_LINE6_C);
									table.insert(outputtable,"  -" ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)");
								end
							end
						end
					else
						if (DKP_ROLL_PLAYERS[bankcharname]['Items'][Firstline]['cost'] > 0) then 
							if (TT_LINE5_D) then
								getdkplootlineSetLine("Listed under the Bank at: " ..DKP_ROLL_PLAYERS[bankcharname]['Items'][Firstline]['cost'].. "DKP", TT_LINE5_C);
								table.insert(outputtable,"Listed under the Bank at: " ..DKP_ROLL_PLAYERS[bankcharname]['Items'][Firstline]['cost'].. "DKP");
							end
						end
					end
				else
					if (playerinraid) then
						if (TT_LINE6_D) then
							getdkplootlineSetLine("  -" ..YELLOW.. "(R) " .. RED .. playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)", TT_LINE6_C);
							table.insert(outputtable,"  -(R) " ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)");
						end
					else
						if (TT_LINE6_D) then
							getdkplootlineSetLine("  -" ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)", TT_LINE6_C);
							table.insert(outputtable,"  -" ..playerNameUpper.. " (" ..DKP_ROLL_PLAYERS[playerName]['RaidPoints'].. "DKP)");
						end
					end					
				end
		end	
		
		if (itemsfound == 0) then 
			if (_itemcount > 0) then
				getdkplootlineSetLine("Non-Set Item", TT_LINE3_C);
				for vPlayer in DKP_ROLL_PLAYERS do
					if (DKP_ROLL_PLAYERS[vPlayer]['Items'] ~= nil) then
						playerNameUpper = string.upper(vPlayer);								
						doesown = false;
						doesown = checkifownsitem(vPlayer, Firstline);
						playerinraid = DKPSYS_chkinraid(vPlayer);

						if (doesown) then
							if (playerinraid) then
								if (TT_LINE7_D) then
									getdkplootlineSetLine("  +" ..YELLOW.. "(R) " .. GREEN .. playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[vPlayer]['Items'][Firstline]['cost'].. "DKP", TT_LINE7_C);
									table.insert(outputtable,"  +(R) " ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[vPlayer]['Items'][Firstline]['cost'].. "DKP");								
								end
								results = results +1;
							else
								if (TT_LINE7_D) then
									getdkplootlineSetLine("  +" ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[vPlayer]['Items'][Firstline]['cost'].. "DKP", TT_LINE7_C);
									table.insert(outputtable,"  +" ..playerNameUpper.. " bought for " ..DKP_ROLL_PLAYERS[vPlayer]['Items'][Firstline]['cost'].. "DKP");								
								end
								results = results +1;
							end
						end
					end
				end
			end
		end

	if (TT_LINE8_D) then
		getdkplootlineSetLine(results.. " Buyer(s) Found", TT_LINE8_C);
		table.insert(outputtable,results.. " Buyer(s) Found");
	end
	
	if (itemsfound > 0) then 
		if (_itemcount > 0) then
			if (TT_LINE9_D) then
				getdkplootlineSetLine(noofplayers-results.. "/" ..noofplayers.. " Players Dont Own This Item", TT_LINE9_C);
				table.insert(outputtable,noofplayers-results.. "/" ..noofplayers.. " Players Dont Own This Item");
			end
		end
	end

	if (results > 0) then
		if (TT_LINE10_D) then
			getdkplootlineSetLine("Normal (AVG) Item Cost: " .._avg.. "DKP", TT_LINE10_C);
			table.insert(outputtable,"Normal (AVG) Item Cost: " .._avg.. "DKP");
		end
	end
	
	if (TT_LINE11_D) then
		if (DKP_ROLL_DB_NAME == "") then
			DKP_ROLL_DB_NAME = "Not Available";	
		end
		getdkplootlineSetLine("DKP System: " ..DKP_ROLL_DB_NAME, TT_LINE11_C);
		table.insert(outputtable,"DKP System: " ..DKP_ROLL_DB_NAME);
	end

	if prisystem == 1 then
		local priloc = {3,5,7,9,11,13,15,17};
		local prinums = {"1","2","3","4","5"};
		local pricount = 1;
		local prevk = 0;

		if (results > 0) then
			if (itempriorities ~= "") then
				prioutput = "";
				prioutput2 = "";
				ipt = split(itempriorities,',');
				for k = 1,5 do
					for chknum in ipt do
						if (ipt[chknum] == prinums[k]) then
							if (prevk ~= k) then
								if prioutput ~= "" then
									prioutput = prioutput.. " " ..RED .. k.. ":" ..ClassColours[ipt[chknum-1]] .. ipt[chknum-1];
									prevk = k;
								else
									prioutput = prioutput ..RED .. k.. ":" ..ClassColours[ipt[chknum-1]] .. ipt[chknum-1];							
									prevk = k;
								end
							else
								prioutput = prioutput .. RED.. "," ..ClassColours[ipt[chknum-1]] .. ipt[chknum-1];
							end
						end
					end
					pricount = pricount+1;
				end
					getdkplootlineSetLine(prioutput, TT_LINE6_C);
					table.insert(outputtable, prioutput);
			end
		end
	end
	
	DKPSysTTPanel:ClearAllPoints();
	DKPSysTTPanel:SetPoint(point, "ItemRefTooltip", relative);
	DKPSysTTPanel:Show();
	Firstline = "";	
	
	elseif (DKPSysTTPanel:IsShown()) then
		DKPSysTTPanel:Hide();
	end
end

function getdkplootlineSetLine(_text,txtcolor,a)
	local r;
	local g;
	local b;

	if txtcolor == "ITEM" then
		r,g,b,a = ItemRefTooltipTextLeft1:GetTextColor();
	else
		r,g,b = DKP_Tooltip_FontColor(txtcolor);
		a = 1;
	end

	if (_text == nil) or (_text == "")  then
		return
	end;
	
	if TooltipLinesLocal >= 30 then
		return
	end;	
	
	if TooltipLinesLocal == 29 then
		getdkplootline = getglobal("DKPSysTTPanelText"..TooltipLinesLocal);						
		getdkplootline:SetText("Exceded Listing Limit, Stopping.") ;
		getdkplootline:SetTextColor(1.0,1.0,1.0) ;	
		getdkplootline:Show();
		TooltipLinesLocal = TooltipLinesLocal + 1 ;
	elseif TooltipLinesLocal < 29 then
		getdkplootline = getglobal("DKPSysTTPanelText"..TooltipLinesLocal);						
		getdkplootline:SetText(_text) ;
		getdkplootline:SetTextColor(r,g,b,a) ;	
		getdkplootline:Show();
		TooltipLinesLocal = TooltipLinesLocal + 1 ;
	end;

	if (getdkplootwidth < getdkplootline:GetStringWidth()) then
		getdkplootwidth = getdkplootline:GetStringWidth()
	end
	
	DKPSysTTPanel:SetHeight(15 * TooltipLinesLocal +18);
	DKPSysTTPanel:SetWidth(getdkplootwidth +20);
end;

-- ############################################################ TOOLTIP REPORT TO CHANNEL FUNCTIONS #######################################
function DKPSYS_post_tooltipitem(channel)
dontdoit = 0;
	
	if channel == "custom" then
		if DKP_TT_Settings.Outputchan == "" then
			DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Output Command: " ..WHITE.. "No custom channel has been set, please use the command /dkptt output channel to set.");
			dontdoit = 1;
		end
	end

	if dontdoit ~= 1 then
		if outputtable ~= "" then
			for k,v in next,outputtable do 
			DKPTT_Output(v,channel)
			end
		end
	end
end

function GDKP_Button_OnEnter(id, description)
	
	if id == "Party" then 
		description = TEXT_DKP_TT_PARTY ;
	elseif id == "Chat" then 
		description = TEXT_DKP_TT_CHAT ;
	elseif id == "Raid" then 
		description = TEXT_DKP_TT_RAID ;
	elseif id == "Guild" then 
		description = TEXT_DKP_TT_GUILD ;
	elseif id == "Officer" then 	
		description = TEXT_DKP_TT_OFFICER ;	
	elseif id == "Custom" then 	
		description = TEXT_DKP_TT_CUSTOM ;
	end;	

	GameTooltip_AddNewbieTip("Tooltip Button "..id, 1, 1, 1, description)
	return
end

function GDKP_Button_OnLeave()
	GameTooltip:Hide()
end

-- ############################################################ Output ############################################################

function DKPTT_Output(msg,_channel)
	if _channel == "lokal" then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	elseif _channel == "RAID" then
		SendChatMessage(msg, "RAID"); 
	elseif _channel == "PARTY" then
		SendChatMessage(msg, "PARTY"); 
	elseif _channel == "GUILD" then	
		SendChatMessage(msg, "GUILD");
	elseif _channel == "SAY" then	
		SendChatMessage(msg, "SAY"); 
	elseif (_channel == "officer") or (_channel == "Officer") then
		SendChatMessage(msg, "Officer"); 
	elseif _channel == "custom" then
		local id, name = GetChannelName(DKP_TT_Settings.Outputchan);					
		SendChatMessage(msg, "CHANNEL", nil, id);
	end; 	
end;

-- ############################################################ SLASH COMMAND HANDLER #####################################################

function DKP_Tooltip_SlashCommandHandler(msg)
	local msgArgs;
	local numArgs;
	
	msg = string.lower(msg);
	msgArgs = GetArgs(msg, " ");
	numArgs = table.getn(msgArgs);

	if (numArgs == 0) then
		DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt location (top, bottom, left, right)" ..WHITE.. " - Sets the location of the tooltip");
		DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt version" ..WHITE.. " - Displays the current DKP_Tooltip Version");
		DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt settings" ..WHITE.. " - Toggles the Settings Window");
		DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt output <channel>" ..WHITE.. " - Sets the Custom Output channel");
	else
			if (msgArgs[1] == "location") then
				if (msgArgs[2] ~= "") then
					if msgArgs[2] == "top" then
						DKP_TT_Settings.Tooltip_Location = "top";
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Tooltip Location now set to top.");
					elseif msgArgs[2] == "left" then
						DKP_TT_Settings.Tooltip_Location = "left";
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Tooltip Location now set to left.");
					elseif msgArgs[2] == "right" then
						DKP_TT_Settings.Tooltip_Location = "right";
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Tooltip Location now set to right.");
					elseif msgArgs[2] == "bottom" then
						DKP_TT_Settings.Tooltip_Location = "bottom";
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Tooltip Location now set to bottom.");
					else
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Please enter /dkptt location then top, bottom, left or right.");
					end
				else
					DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Location Command: " ..WHITE.. "Please enter /dkptt location then top, bottom, left or right.");				
				end
			elseif (msgArgs[1] == "version") then
				DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Version: " ..WHITE.. "You are using DKP_Tooltip version " ..version);
			elseif (msgArgs[1] == "settings") then
				DKP_Tooltip_Settings_Toggle();
			elseif (msgArgs[1] == "output") then
				if msgArgs[2] == nil then
					if DKP_TT_Settings.Outputchan == "" then
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Output Command: " ..WHITE.. "You need to specify a channel, please use the command /dkptt output channel to set.");
					else
						DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Output Command: " ..WHITE.. "Custom Output Channel is currently set to: " ..DKP_TT_Settings.Outputchan.. ".");
					end

				else
					DKP_TT_Settings.Outputchan = msgArgs[2];
					DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "Output Command: " ..WHITE.. "Custom Output Channel has been set to: " ..msgArgs[2].. ".");	
				end
			else	
				DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt location (top, bottom, left, right)" ..WHITE.. " - Sets the location of the tooltip");
				DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt version" ..WHITE.. " - Displays the current DKP_Tooltip Version");
				DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt settings" ..WHITE.. " - Toggles the Settings Window");
				DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_TOOLTIP: " ..YELLOW.. "/dkptt output <channel>" ..WHITE.. " - Sets the Custom Output channel");
			end
	end	
end;

-- ############################################################ SETTINGS WINDOW FUNCTIONS #################################################

function DKP_Tooltip_Settings_Toggle()
	if(DKPTooltipSettingsFrame:IsVisible()) then
		DKPTooltipSettingsFrame:Hide();
	else
		DKPTooltipSettingsFrame:Show();
	end
end

function DKP_Tooltip_Settings_OnLoad()
	UIPanelWindows['DKPTooltipSettingsFrame'] = {area = 'center', pushable = 0};
end

-- function DKP_Tooltip_Settings_Activate()
-- 	if DKP_Tooltip_Settings_Activated:GetChecked() == 1 then
-- 		Disablethismod = false;
-- 		DKP_TT_Settings.Activated = "on"; 
-- 	else
-- 		Disablethismod = true;
-- 		DKP_TT_Settings.Activated = "off"; 
-- 	end
-- end

function DKP_Tooltip_Settings_OnShow()
	local TT_LINE2_C_TEMP = "";
	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE1_C);
	DKP_Tooltip_Settings_Line1:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line1_SL:SetValue(n);
		if TT_LINE1_C == "ITEM" then
			DKP_Tooltip_Settings_Line1_ItemColour:SetChecked(true);
		else
			DKP_Tooltip_Settings_Line1_ItemColour:SetChecked(false);
		end
	-- 	if (Disablethismod) then
	-- 		DKP_Tooltip_Settings_Activated:SetChecked(false);
	-- 	else
			-- DKP_Tooltip_Settings_Activated:SetChecked(true);
	-- 		DEFAULT_CHAT_FRAME:AddMessage("sadfasfasf");
	-- 	end

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE2_C);
	DKP_Tooltip_Settings_Line2:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line2_SL:SetValue(n);
	DKP_Tooltip_Settings_Line2_CB:SetChecked(TT_LINE2_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE3_C);
	DKP_Tooltip_Settings_Line3:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line3_SL:SetValue(n);
	DKP_Tooltip_Settings_Line3_CB:SetChecked(TT_LINE3_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE4_C);
	DKP_Tooltip_Settings_Line4:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line4_SL:SetValue(n);
	DKP_Tooltip_Settings_Line4_CB:SetChecked(TT_LINE4_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE5_C);
	DKP_Tooltip_Settings_Line5:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line5_SL:SetValue(n);
	DKP_Tooltip_Settings_Line5_CB:SetChecked(TT_LINE5_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE6_C);
	DKP_Tooltip_Settings_Line6:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line6_SL:SetValue(n);
	DKP_Tooltip_Settings_Line6_CB:SetChecked(TT_LINE6_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE7_C);
	DKP_Tooltip_Settings_Line7:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line7_SL:SetValue(n);
	DKP_Tooltip_Settings_Line7_CB:SetChecked(TT_LINE7_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE8_C);
	DKP_Tooltip_Settings_Line8:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line8_SL:SetValue(n);
	DKP_Tooltip_Settings_Line8_CB:SetChecked(TT_LINE8_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE9_C);
	DKP_Tooltip_Settings_Line9:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line9_SL:SetValue(n);
	DKP_Tooltip_Settings_Line9_CB:SetChecked(TT_LINE9_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE10_C);
	DKP_Tooltip_Settings_Line10:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line10_SL:SetValue(n);
	DKP_Tooltip_Settings_Line10_CB:SetChecked(TT_LINE10_D);

	r,g,b,n = DKP_Tooltip_FontColor(TT_LINE11_C);
	DKP_Tooltip_Settings_Line11:SetTextColor(r,g,b);
	DKP_Tooltip_Settings_Line11_SL:SetValue(n);
	DKP_Tooltip_Settings_Line11_CB:SetChecked(TT_LINE11_D);
end

function DKP_Tooltip_Settings_SL_Int(slider)
    local sl = getglobal(slider)
    getglobal(slider .. "Low"):SetText("");
	getglobal(slider .. "High"):SetText(""); 
	getglobal(slider .. "Text"):SetText("");
end

function DKP_Tooltip_Settings_SL_Ent()
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	if (this:GetValue() == 1) then
		GameTooltip:SetText("Red");
	elseif (this:GetValue() == 2) then
		GameTooltip:SetText("Green");
	elseif (this:GetValue() == 3) then
		GameTooltip:SetText("Blue");
	elseif (this:GetValue() == 4) then
		GameTooltip:SetText("Magenta");
	elseif (this:GetValue() == 5) then
		GameTooltip:SetText("Yellow");
	elseif (this:GetValue() == 6) then
		GameTooltip:SetText("Cyan");
	else
		GameTooltip:SetText("White");
	end
end

function DKP_Tooltip_Settings_SL_Changed(slider, lineno)
	GameTooltip:SetText(this:GetValue());
	if (this:GetValue() == 1) then
		GameTooltip:SetText("Red");
		r,g,b = DKP_Tooltip_FontColor("RGB_RED");
		lineno = "RGB_RED";
	elseif (this:GetValue() == 2) then
		GameTooltip:SetText("Green");
		r,g,b = DKP_Tooltip_FontColor("RGB_GREEN");
		lineno = "RGB_GREEN";
	elseif (this:GetValue() == 3) then
		GameTooltip:SetText("Blue");
		r,g,b = DKP_Tooltip_FontColor("RGB_BLUE");							
		lineno = "RGB_BLUE";
	elseif (this:GetValue() == 4) then
		GameTooltip:SetText("Magenta");
		r,g,b = DKP_Tooltip_FontColor("RGB_MAGENTA");
		lineno = "RGB_MAGENTA";
	elseif (this:GetValue() == 5) then
		GameTooltip:SetText("Yellow");
		r,g,b = DKP_Tooltip_FontColor("RGB_YELLOW");
		lineno = "RGB_YELLOW";
	elseif (this:GetValue() == 6) then
		GameTooltip:SetText("Cyan");
		r,g,b = DKP_Tooltip_FontColor("RGB_CYAN");
		lineno = "RGB_CYAN";
	else
		GameTooltip:SetText("White");
		r,g,b = DKP_Tooltip_FontColor("RGB_WHITE");
		lineno = "RGB_WHITE";
	end
end

function DKP_Tooltip_Settings_SaveClose()
	TT_LINE1_C = DKP_Tooltip_FontColor_REV(TT_LINE1_C_TEMP);
	DKP_TT_Settings.TT_LINE1_C = DKP_Tooltip_FontColor_REV(TT_LINE1_C_TEMP);
	if DKP_Tooltip_Settings_Line1_ItemColour:GetChecked() == 1 then
		TT_LINE1_C = "ITEM";
		DKP_TT_Settings.TT_LINE1_C = "ITEM";
	end
	TT_LINE2_C = DKP_Tooltip_FontColor_REV(TT_LINE2_C_TEMP);
	DKP_TT_Settings.TT_LINE2_C = DKP_Tooltip_FontColor_REV(TT_LINE2_C_TEMP);
	TT_LINE3_C = DKP_Tooltip_FontColor_REV(TT_LINE3_C_TEMP);
	DKP_TT_Settings.TT_LINE3_C = DKP_Tooltip_FontColor_REV(TT_LINE3_C_TEMP);
	TT_LINE4_C = DKP_Tooltip_FontColor_REV(TT_LINE4_C_TEMP);
	DKP_TT_Settings.TT_LINE4_C = DKP_Tooltip_FontColor_REV(TT_LINE4_C_TEMP);
	TT_LINE5_C = DKP_Tooltip_FontColor_REV(TT_LINE5_C_TEMP);
	DKP_TT_Settings.TT_LINE5_C = DKP_Tooltip_FontColor_REV(TT_LINE5_C_TEMP);
	TT_LINE6_C = DKP_Tooltip_FontColor_REV(TT_LINE6_C_TEMP);
	DKP_TT_Settings.TT_LINE6_C = DKP_Tooltip_FontColor_REV(TT_LINE6_C_TEMP);
	TT_LINE7_C = DKP_Tooltip_FontColor_REV(TT_LINE7_C_TEMP);
	DKP_TT_Settings.TT_LINE7_C = DKP_Tooltip_FontColor_REV(TT_LINE7_C_TEMP);
	TT_LINE8_C = DKP_Tooltip_FontColor_REV(TT_LINE8_C_TEMP);
	DKP_TT_Settings.TT_LINE8_C = DKP_Tooltip_FontColor_REV(TT_LINE8_C_TEMP);
	TT_LINE9_C = DKP_Tooltip_FontColor_REV(TT_LINE9_C_TEMP);
	DKP_TT_Settings.TT_LINE9_C = DKP_Tooltip_FontColor_REV(TT_LINE9_C_TEMP);
	TT_LINE10_C = DKP_Tooltip_FontColor_REV(TT_LINE10_C_TEMP);
	DKP_TT_Settings.TT_LINE10_C = DKP_Tooltip_FontColor_REV(TT_LINE10_C_TEMP);
	TT_LINE11_C = DKP_Tooltip_FontColor_REV(TT_LINE11_C_TEMP);
	DKP_TT_Settings.TT_LINE11_C = DKP_Tooltip_FontColor_REV(TT_LINE11_C_TEMP);
	if DKP_Tooltip_Settings_Line2_CB:GetChecked() == 1 then
		TT_LINE2_D = true;
		DKP_TT_Settings.TT_LINE2_D = "on";
	else
		TT_LINE2_D = false;
		DKP_TT_Settings.TT_LINE2_D = "off";
	end
	if DKP_Tooltip_Settings_Line3_CB:GetChecked() == 1 then
		TT_LINE3_D = true;
		DKP_TT_Settings.TT_LINE3_D = "on"; 
	else
		TT_LINE3_D = false;
		DKP_TT_Settings.TT_LINE3_D = "off"; 
	end
	if DKP_Tooltip_Settings_Line4_CB:GetChecked() == 1 then
		TT_LINE4_D = true;
		DKP_TT_Settings.TT_LINE4_D = "on"; 
	else
		TT_LINE4_D = false;
		DKP_TT_Settings.TT_LINE4_D = "off"; 
	end
	if DKP_Tooltip_Settings_Line5_CB:GetChecked() == 1 then
		TT_LINE5_D = true;
		DKP_TT_Settings.TT_LINE5_D = "on"; 
	else
		TT_LINE5_D = false;
		DKP_TT_Settings.TT_LINE5_D = "off"; 
	end
	if DKP_Tooltip_Settings_Line6_CB:GetChecked() == 1 then
		TT_LINE6_D = true;
		DKP_TT_Settings.TT_LINE6_D = "on";
	else
		TT_LINE6_D = false;
		DKP_TT_Settings.TT_LINE6_D = "off";
	end
	if DKP_Tooltip_Settings_Line7_CB:GetChecked() == 1 then
		TT_LINE7_D = true;
		DKP_TT_Settings.TT_LINE7_D = "on"; 
	else
		TT_LINE7_D = false;
		DKP_TT_Settings.TT_LINE7_D = "off"; 
	end
	if DKP_Tooltip_Settings_Line8_CB:GetChecked() == 1 then
		TT_LINE8_D = true;
		DKP_TT_Settings.TT_LINE8_D = "on"; 
	else
		TT_LINE8_D = false;
		DKP_TT_Settings.TT_LINE8_D = "off"; 
	end
	if DKP_Tooltip_Settings_Line9_CB:GetChecked() == 1 then
		TT_LINE9_D = true;
		DKP_TT_Settings.TT_LINE9_D = "on";
	else
		TT_LINE9_D = false;
		DKP_TT_Settings.TT_LINE9_D = "off";
	end
	if DKP_Tooltip_Settings_Line10_CB:GetChecked() == 1 then
		TT_LINE10_D = true;
		DKP_TT_Settings.TT_LINE10_D = "on";
	else
		TT_LINE10_D = false;
		DKP_TT_Settings.TT_LINE10_D = "off";
	end
	if DKP_Tooltip_Settings_Line11_CB:GetChecked() == 1 then
		TT_LINE11_D = true;
		DKP_TT_Settings.TT_LINE11_D = "on";
	else
		TT_LINE11_D = false;
		DKP_TT_Settings.TT_LINE11_D = "off";
	end
	DKP_Tooltip_Settings_Toggle();
end

function DKP_Tooltip_Settings_OnHide()
	if(MYADDONS_ACTIVE_OPTIONSFRAME == this) then
		ShowUIPanel(myAddOnsFrame);
	end
end

-- ############################################################ MISC FUNCTIONS ############################################################

--[[
--	checkifownsitem(chkname, chkitem);
--	
--	description:
--		- Checks to see if given name has given item
--
--	args: 
--		- chkname	: [string] playername
--		- chkitem	: [string] itemname
--
--	returns:
--		- doesown	: [boolean] true if player has item
--		- bankitem	: [boolean] true if item found on bank player
--]]

function checkifownsitem(chkname, chkitem)
	doesown = false;
	bankitem = false;
		for chkitemName, chkitemCost in DKP_ROLL_PLAYERS[chkname]['Items'] do
			if ((string.find(chkitemName, chkitem))) then
				if string.lower(chkname) == bankcharname then
					bankitem = true;
					itempriorities = DKP_ROLL_PLAYERS[chkname]['Items'][chkitem]['priorities'];
					return doesown,bankitem,itempriorities;
				else
					doesown = true;
					itempriorities = DKP_ROLL_PLAYERS[chkname]['Items'][chkitem]['priorities'];
				end
			end
		end
	return doesown,bankitem,itempriorities;
end

--[[
--	DKPSYS_GetLinkID_FromLinkedItemname(msg);
--	
--	description:
--		- Extracts Item id from Link
--
--	args: 
--		- msg	: [string] Item Link
--
--	returns:
--		- areturn_link	: [string] item link
--]]

function DKPSYS_GetLinkID_FromLinkedItemname(msg)
local areturn_link  = "";
 	if (msg ~= nil) and (msg ~= "" ) then
		for color, item, name in string.gfind(msg, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
			if( color and item and name and name ~= "" ) then				
					 areturn_link = string.gsub(item, "^(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4");					 
			end;
		end
	end
return areturn_link ;	
end;

function get_Informations_of_Item(msg)
local color;
local item;
local name;
local itemlink ;
local aclassde = "" ;
local aclasseng = "" ;
local anamede = "" ;
local anameeng = "" ;
local atier = "" ;
local adrop = "" ;
local LLItemlinkText = "" ;
local ItemName, ItemValues ;
local flag ;
local itemtable = {}
local i;

	itemlink = DKPSYS_GetLinkID_FromLinkedItemname(msg);
	-- itemlink respond directly out gdkp_sets 
	if gdkp_sets.items[itemlink] ~= nil then 
		aclassde = gdkp_sets.items[itemlink].Class_de; 
		aclasseng = gdkp_sets.items[itemlink].Class_eng; 
		anamede = gdkp_sets.items[itemlink].name_de; 
		anameeng = gdkp_sets.items[itemlink].name_eng; 
		atier = gdkp_sets.items[itemlink].Tier; 
		adrop = gdkp_sets.items[itemlink].droptby; 
	else -- tooltip, tests for names in gdkp_sets 
		for key, val in gdkp_sets.items do 
			if (msg == val.name_de) or (msg == val.name_eng) then
				aclassde = val.Class_de
				aclasseng = val.Class_eng
				anamede = val.name_de
				anameeng = val.name_eng
				atier = val.Tier
				adrop = val.droptby
			end;			
		end
	end;
		
	-- lootlink search
	if aclassde == "" and ItemLinks ~= nil then
		--built e real [item] from Itemname
		LLItemlinkText = DKPSYS_Check_Loot_Text(msg) ;
		itemlink = "";
		color = "";
		item = "";
		name = "";
		itemlink = "";
		
		i = 1 ;
		-- search for itemlink from [item] to get Itemid
		itemlink = DKPSYS_GetLinkID_FromLinkedItemname(LLItemlinkText);
		if itemlink ~= "" then -- search for ItemID in Lootlink
			for ItemName, ItemValues in ItemLinks do				
				if ItemLinks[ItemName]['i'] == itemlink then  -- if LootlinkID match with ID from given Item
					itemtable[i] = ItemName; --insert into arry if more than one name
					i = i+1 ;	
				end
			end
			
			if itemtable[1] ~= nil then
				anamede = itemtable[1] ;
			end;	
			if itemtable[2] ~= nil then
				anameeng = itemtable[2] ;
			end;
		end;	
	end;
	
	if anameeng == "" then
		anameeng = msg;
	end;

	return aclassde,aclasseng,anamede,anameeng,atier,adrop ;
end;

function DKPSYS_Check_Loot_Text(checkItemName) 
if checkItemName == nil or checkItemName == "" then
return ;
end;

		local ItemName, ItemValues;
		local ItemFound = false;
		
		local IMitem;
		local ItemColor, ItemCode;
		
		local ItemText = "";
				

		if ((ItemLinks == nil) and (IMDB == nil)) then
				-- If lootlink isn't installed, just return back with original text
				return checkItemName; 
		end
		
		-- ItemMatrix Code
		if (IMDB ~= nil) then
				--DEFAULT_CHAT_FRAME:AddMessage("ItemMatrix Found");
		
				-- Sort out IM's garble
				-- ffffffff6265:0:0:46458008
				local pattern_im_item = "(.+)(.+)";						
				
				for ItemName, ItemValues in IMDB do
						if (string.lower(ItemName) == string.lower(checkItemName)) then														
								--DEFAULT_CHAT_FRAME:AddMessage("Item Found.");						
								
								IMitem = IMDB[ItemName];
								
								for ItemColor, ItemCode in string.gfind(IMitem, pattern_im_item) do															
										ItemText = "|c".. ItemColor .."|Hitem:".. ItemCode .."|h[".. ItemName .."]|h|r";
										ItemFound = true;
								end
						end
						
				end																							

		-- LootLink Code
		else
				--DEFAULT_CHAT_FRAME:AddMessage("Lootlink Found");
				for ItemName, ItemValues in ItemLinks do
						if (string.lower(ItemName) == string.lower(checkItemName)) then
								ItemFound = true;
								
								ItemText = "|c".. ItemLinks[ItemName]['c'] .."|Hitem:".. ItemLinks[ItemName]['i'] .."|h[".. ItemName .."]|h|r";				
						end
				end
		end
		
		if (ItemFound) then
				return ItemText;
		else
				return checkItemName;
		end
end

function DKPSYS_item_info(aItemLookup)
	local count = 0 ;
	local realcount = 0 ;
	local _min = 99999  ;
	local _max = 0 ;
	local _avg = 0 ;
	local CLASSNAME_DE = "" ;
	local CLASSNAME_ENG = "" ;
	local anamede = "" ;
	local anameeng = "" ;
	local atier = "" ;
	local adrop = "" ;
	local ignoreValue = 0 ;
	local aplayerName, aplayerArray, aplayerKey, aplayerValue

	CLASSNAME_DE,CLASSNAME_ENG,anamede,anameeng,atier,adrop = get_Informations_of_Item(aItemLookup) ;

	if DKP_ROLL_PLAYERS == nil then
		return 0,0,0,0 ;
	end;

	for vPlayer in DKP_ROLL_PLAYERS do
		if (DKP_ROLL_PLAYERS[vPlayer]['Items'] ~= nil) then
			for vItem, vCost in DKP_ROLL_PLAYERS[vPlayer]['Items'] do
				if (vItem == anamede) or (vItem == anameeng) then 
					count = count + 1 ;
					if ignoreValue ~= vCost then
						if (string.lower(vPlayer) ~= bankcharname) then
							realcount = realcount + 1 ;
							if DKP_ROLL_PLAYERS[vPlayer]['Items'][vItem]['cost'] < _min then
							  _min = DKP_ROLL_PLAYERS[vPlayer]['Items'][vItem]['cost'] ;
							end;
		
							if DKP_ROLL_PLAYERS[vPlayer]['Items'][vItem]['cost'] > _max then
								_max = DKP_ROLL_PLAYERS[vPlayer]['Items'][vItem]['cost']
							end;
			
							_avg = _avg + DKP_ROLL_PLAYERS[vPlayer]['Items'][vItem]['cost'] ;							
						end
					end;	
				end;
			end
		end
	end		
	
	if count > 0 then
		_avg = math.ceil(_avg / realcount)  ;
		if _min == 99999 then
			_min = 0 ;
		end;
			return _min,_max,_avg,count
	else
		return 0,0,0,0 ;
	end;
end

function split(str, pat)
   local t = {n = 0}
   local fpat = "(.-)"..pat
   local last_end = 1
   local s,e,cap = string.find(str, fpat, 1)
   while s ~= nil do
      if s~=1 or cap~="" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s,e,cap = string.find(str, fpat, last_end)
   end
   if last_end<=string.len(str) then
      cap = string.sub(str,last_end)
      table.insert(t,cap)
   end
   return t
end

function DKPSYS_chkinraid(player)
local areturn = false ;

	if player == nil or player == "" then
		return areturn
	else
		if  GetNumRaidMembers()  > 0 then
			for i = 1,GetNumRaidMembers() do 
				--debug(msg.." "..string.lower(GetRaidRosterInfo(i)));
				if GetRaidRosterInfo(i) ~= nil then
					if string.lower(player) == string.lower(GetRaidRosterInfo(i)) then 
					areturn = true ;
					end;
				end;	
			end; 
		else
			areturn = false ;					--display everything when not in a raid
		end;	
	end;	
	
return areturn	
end;	


function DKP_Tooltip_FontColor(tcolor)
	if tcolor == "RGB_RED" then
		r = 1.0;
		g = 0.0;
		b = 0.0;
		n = 1;
	elseif tcolor == "RGB_GREEN" then
		r = 0.2;
		g = 0.8;
		b = 0.0;
		n = 2;
	elseif tcolor == "RGB_BLUE" then
		r = 0.0;
		g = 0.0;
		b = 1.0;
		n = 3;	
	elseif tcolor == "RGB_MAGENTA" then
		r = 0.8;
		g = 0.0;
		b = 1.0;
		n = 4;
	elseif tcolor == "RGB_YELLOW" then
		r = 1.0;
		g = 1.0;
		b = 0.0;
		n = 5;
	elseif tcolor == "RGB_CYAN" then
		r = 0.0;
		g = 1.0;
		b = 1.0;
		n = 6;
	elseif tcolor == "RGB_WHITE" then
		r = 1.0;
		g = 1.0;
		b = 1.0;
		n = 7;
	else
		r = 1.0;
		g = 1.0;
		b = 1.0;
		n = 8;		
	end
	return r,g,b,n;
end

function DKP_Tooltip_FontColor_REV(tcolnum)
	if tcolnum == 1 then
		n = "RGB_RED";
	elseif tcolnum == 2 then
		n = "RGB_GREEN";
	elseif tcolnum == 3 then
		n = "RGB_BLUE";	
	elseif tcolnum == 4 then
		n = "RGB_MAGENTA";
	elseif tcolnum == 5 then
		n = "RGB_YELLOW";
	elseif tcolnum == 6 then
		n = "RGB_CYAN";
	elseif tcolnum == 7 then
		n = "RGB_WHITE";
	else
		n = "RGB_WHITE";		
	end
	return n;
end